(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ionic/angular')) :
    typeof define === 'function' && define.amd ? define('ion-back-button-tabs', ['exports', '@angular/core', '@ionic/angular'], factory) :
    (factory((global['ion-back-button-tabs'] = {}),global.ng.core,global['@ionic/angular']));
}(this, (function (exports,core,angular) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BackButtonTabsDirective = /** @class */ (function () {
        function BackButtonTabsDirective(routerOutlet, navCtrl) {
            this.routerOutlet = routerOutlet;
            this.navCtrl = navCtrl;
        }
        /**
         * @param {?} ev
         * @return {?}
         */
        BackButtonTabsDirective.prototype.onClick = /**
         * @param {?} ev
         * @return {?}
         */
            function (ev) {
                /** @type {?} */
                var lastTabUrl;
                if (this.routerOutlet) {
                    /** @type {?} */
                    var nonCrclrRtrOtlt = JSON.parse(JSON.stringify(this.routerOutlet, this.getCircularReplacer()));
                    if (this.backToTabs(nonCrclrRtrOtlt)) {
                        lastTabUrl = this.getActiveTabViewUrl();
                    }
                }
                if (this.routerOutlet && this.routerOutlet.canGoBack() && lastTabUrl) {
                    this.navCtrl.navigateBack(lastTabUrl);
                    ev.preventDefault();
                }
                else if (this.routerOutlet && this.routerOutlet.canGoBack()) {
                    this.routerOutlet.pop();
                    ev.preventDefault();
                }
                else if (this.defaultHref != null) {
                    this.navCtrl.navigateBack(this.defaultHref);
                    ev.preventDefault();
                }
            };
        /**
         * @private
         * @param {?} nonCrclrRtrOtlt
         * @return {?}
         */
        BackButtonTabsDirective.prototype.backToTabs = /**
         * @private
         * @param {?} nonCrclrRtrOtlt
         * @return {?}
         */
            function (nonCrclrRtrOtlt) {
                /** @type {?} */
                var views = nonCrclrRtrOtlt.stackCtrl.views;
                /** @type {?} */
                var topUrls = [];
                for (var i = 0; i < views.length; i++) {
                    if (views[i]) {
                        topUrls.push(views[i].url);
                    }
                }
                return (topUrls[topUrls.length - 1] === "/" + this.tabsPrefix);
            };
        /**
         * @private
         * @return {?}
         */
        BackButtonTabsDirective.prototype.getActiveTabViewUrl = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var views = this.routerOutlet.location._embeddedViews;
                for (var i = 0; i < views.length; i++) {
                    for (var j = 0; j < views[i].nodes.length; j++) {
                        if (views[i].nodes[j].renderElement && views[i].nodes[j].renderElement.localName === this.tabsPageSelector) {
                            for (var k = 0; k < views[i].nodes[j].componentView.nodes.length; k++) {
                                if (views[i].nodes[j].componentView.nodes[k].renderElement
                                    && views[i].nodes[j].componentView.nodes[k].renderElement.localName === 'ion-tabs') {
                                    /** @type {?} */
                                    var activeTab = views[i].nodes[j].componentView.nodes[k]
                                        .componentView.context.outlet.stackCtrl.getActiveStackId();
                                    return views[i].nodes[j].componentView.nodes[0]
                                        .componentView.context.outlet.stackCtrl.getLastUrl(activeTab).url;
                                }
                            }
                        }
                    }
                }
                return;
            };
        /**
         * @private
         * @return {?}
         */
        BackButtonTabsDirective.prototype.getCircularReplacer = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var seen = new WeakSet;
                return ( /**
                 * @param {?} key
                 * @param {?} value
                 * @return {?}
                 */function (key, value) {
                    if (typeof value === 'object' && value !== null) {
                        if (seen.has(value)) {
                            return;
                        }
                        seen.add(value);
                    }
                    return value;
                });
            };
        BackButtonTabsDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ionBackButtonTabs]'
                    },] }
        ];
        /** @nocollapse */
        BackButtonTabsDirective.ctorParameters = function () {
            return [
                { type: angular.IonRouterOutlet, decorators: [{ type: core.Optional }] },
                { type: angular.NavController }
            ];
        };
        BackButtonTabsDirective.propDecorators = {
            defaultHref: [{ type: core.Input }],
            tabsPrefix: [{ type: core.Input }],
            tabsPageSelector: [{ type: core.Input }],
            onClick: [{ type: core.HostListener, args: ['click', ['$event'],] }]
        };
        return BackButtonTabsDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BackButtonTabsComponent = /** @class */ (function () {
        function BackButtonTabsComponent() {
        }
        BackButtonTabsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ion-back-button-tabs',
                        template: "<ion-back-button\n    [defaultHref]=\"defaultHref\"\n    [tabsPrefix]=\"tabsPrefix\"\n    [tabsPageSelector]=\"tabsPageSelector\"\n    ionBackButtonTabs></ion-back-button>"
                    }] }
        ];
        BackButtonTabsComponent.propDecorators = {
            defaultHref: [{ type: core.Input }],
            tabsPrefix: [{ type: core.Input }],
            tabsPageSelector: [{ type: core.Input }]
        };
        return BackButtonTabsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BackButtonTabsModule = /** @class */ (function () {
        function BackButtonTabsModule() {
        }
        BackButtonTabsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            angular.IonicModule
                        ],
                        declarations: [
                            BackButtonTabsDirective,
                            BackButtonTabsComponent
                        ],
                        exports: [
                            BackButtonTabsComponent
                        ]
                    },] }
        ];
        return BackButtonTabsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.BackButtonTabsDirective = BackButtonTabsDirective;
    exports.BackButtonTabsComponent = BackButtonTabsComponent;
    exports.BackButtonTabsModule = BackButtonTabsModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ion-back-button-tabs.umd.js.map